function y = GL4(T,N,m0,q0,I,tol)
            h=T/2^N;
            tend = length(0:h:T)-1;
            M(:,1) = m0;
            Q(:,1) = q0;
            y(:,1) = [M(:,1);Q(:,1)];               
    for t=1:tend 
            e = 1;
            k_m1_0 = zeros(3,1);
            k_q1_0 = zeros(4,1);
            k_m2_0 = zeros(3,1);
            k_q2_0 = zeros(4,1);
            while e>tol
             k_m1=  getMdot(M(:,t) + .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0 ,t,I);
             k_q1=  getQdot(M(:,t)+ .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0 ,...
                            Q(:,t)+ .25*h*k_q1_0 + (.25 - sqrt(3)/6)*h*k_q2_0 ,I);

             k_m2= getMdot(M(:,t) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0, t + .5*h,I);
             k_q2= getQdot(M(:,t) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0,...
                           Q(:,t) + (.25 + sqrt(3)/6)*h*k_q1_0 + .25*h*k_q2_0,I);

             k_m1_0 = k_m1;
             k_q1_0 = k_q1;
             k_m2_0 = k_m2;
             k_q2_0 = k_q2;

             Ekm1 = k_m1-  getMdot(M(:,t) + .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0 ,t,I);
             Ekq1 = k_q1-  getQdot(M(:,t)+ .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0 ,...
                            Q(:,t)+ .25*h*k_q1_0 + (.25 - sqrt(3)/6)*h*k_q2_0 ,I);

             Ekm2 = k_m2- getMdot(M(:,t) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0, t + .5*h,I);
             Ekq2 = k_q2- getQdot(M(:,t) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0,...
                           Q(:,t) + (.25 + sqrt(3)/6)*h*k_q1_0 + .25*h*k_q2_0,I);
               e = norm([Ekm1;Ekm2;Ekq1;Ekq2]);
            end
        k_m(:,1) = k_m1;
        k_q(:,1) = k_q1;
        k_m(:,2) = k_m2;
        k_q(:,2) = k_q2;
         M(:,t+1) = M(:,t) + h*(1/2)*k_m*[1;1];
         Q(:,t+1) = Q(:,t) + h*(1/2)*k_q*[1;1];
    % renormalize Q
%         Q(:,t+1) = Q(:,t+1) ./ sqrt(dot(Q(:,t+1),Q(:,t+1))); 
       y(:,t+1) = [M(:,t+1);Q(:,t+1)];
    end
end
%% Euler Equation
function [Mdot] = getMdot(M,T,I)
Imat_inv = diag(diag(1./I));
Mdot = cross(M,Imat_inv*M);                                     
end
%% Arnold Equation
function [Qdot]=getQdot(M,Quat,I)
I = diag(I);
R =RotationMatrix(Quat);
invI = diag(1./I);
w = invI*M;
w_f = R*w;
Qdot = .5*quatMult(([0;w_f])',Quat');
Qdot = Qdot';
end
%% Rotation Matrix
function [R]=RotationMatrix(Quat)
R = [(1-2*(Quat(3)^2 + Quat(4)^2))         ,(-2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3))  , (2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4));
     (2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3)) , (1 - 2*(Quat(2)^2 + Quat(4)^2))        , (-2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4));
    (-2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4)) , (2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4))  , (1 - 2*(Quat(2)^2 + Quat(3)^2)) ];
end
%% Quaternion Multiplication
function [crossProd]=quatMult(q1,q2)
s1 = q1(1); v1 = q1(2:4);
s2 = q2(1); v2 = q2(2:4);
crossProd = [ s1*s2 - dot(v1,v2), s1*v2 + s2*v1 + cross(v1,v2)];
end