function y = IM(T,N,m0,q0,I,tol)
        h=T/2^N;
        tend = length(0:h:T)-1;
        y=zeros(7,2^N+1);
        y(:,1) = [m0;q0];    
        for i=1:tend     
                e=1.;
                y_k0=zeros(7,1);
            while e>tol
               mid =(y(:,i) + y_k0)/2;
               f=[getMdot(mid(1:3),T,I);getQdot(mid(1:3),mid(4:7),I)];
               y_k1  = y(:,i) + h*f;
               y_k0 = y_k1;
               mid1 = (y(:,i) + y_k1)/2;
               f1=[getMdot(mid1(1:3),T,I);getQdot(mid1(1:3),mid1(4:7),I)];
               e=norm(y_k1 - y(:,i) - h*f1);
            end   
            y(:,i+1)=y_k1;       
        end
end    
%% Euler Equation
function [Mdot] = getMdot(M,T,I)
Imat_inv = diag(diag(1./I));
Mdot = cross(M,Imat_inv*M);                                     
end
%% Arnold Equation
function [Qdot]=getQdot(M,Quat,I)
I = diag(I);
R =RotationMatrix(Quat);
invI = diag(1./I);
w = invI*M;
w_f = R*w;
Qdot = .5*quatMult(([0;w_f])',Quat');
Qdot = Qdot';
end
%% Rotation Matrix
function [R]=RotationMatrix(Quat)
R = [(1-2*(Quat(3)^2 + Quat(4)^2))         ,(-2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3))  , (2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4));
     (2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3)) , (1 - 2*(Quat(2)^2 + Quat(4)^2))        , (-2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4));
    (-2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4)) , (2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4))  , (1 - 2*(Quat(2)^2 + Quat(3)^2)) ];
end
%% Quaternion Multiplication
function [crossProd]=quatMult(q1,q2)
s1 = q1(1); v1 = q1(2:4);
s2 = q2(1); v2 = q2(2:4);
crossProd = [ s1*s2 - dot(v1,v2), s1*v2 + s2*v1 + cross(v1,v2)];
end