function y = KM(T,N,m0,q0,I,tol)
            h=T/2^N;
            tmax = length(0:h:T)-1;
            y=zeros(7,tmax);
            y(:,1) = [m0;q0];
            for i=1:tmax    
                e=1.;
                y_k0=zeros(7,1);
                fn(:,i) = [getMdot(y(1:3,i),T,I);getQdot(y(1:3,i),y(4:end,i),I)]; 
                iter = 0;
                while e>tol
                    y_k1 = y(:,i) - h/2*fn(:,i) +...
                           2*h*[getMdot((y_k0(1:3,1)+y(1:3,i))/2,T,I);...
                                 getQdot((y_k0(1:3,1)+y(1:3,i))/2,(y_k0(4:end,1)+y(4:end,i))/2,I)]-...
                           1/2*h*[getMdot(y_k0(1:3,1),T,I);getQdot(y_k0(1:3,1),y_k0(4:7,1),I)];
                     y_k0 = y_k1;

                     er =  y_k1 - y(:,i) + h/2*fn(:,i) -...
                           2*h*[getMdot((y_k0(1:3,1)+y(1:3,i))/2,T,I);...
                                 getQdot((y_k0(1:3,1)+y(1:3,i))/2,(y_k0(4:end,1)+y(4:end,i))/2,I)] +...
                           1/2*h*[getMdot(y_k0(1:3,1),T,I);getQdot(y_k0(1:3,1),y_k0(4:7,1),I)];          
                      e = norm(er);
                      iter = iter + 1;
                end   
                y(:,i+1)=y_k1;  
            end            
end    
%% Euler Equation
function [Mdot] = getMdot(M,T,I)
Imat_inv = diag(diag(1./I));
Mdot = cross(M,Imat_inv*M);                                     
end
%% Arnold Equation
function [Qdot]=getQdot(M,Quat,I)
I = diag(I);
R =RotationMatrix(Quat);
invI = diag(1./I);
w = invI*M;
w_f = R*w;
Qdot = .5*quatMult(([0;w_f])',Quat');
Qdot = Qdot';
end
%% Rotation Matrix
function [R]=RotationMatrix(Quat)
R = [(1-2*(Quat(3)^2 + Quat(4)^2))         ,(-2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3))  , (2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4));
     (2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3)) , (1 - 2*(Quat(2)^2 + Quat(4)^2))        , (-2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4));
    (-2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4)) , (2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4))  , (1 - 2*(Quat(2)^2 + Quat(3)^2)) ];
end
%% Quaternion Multiplication
function [crossProd]=quatMult(q1,q2)
s1 = q1(1); v1 = q1(2:4);
s2 = q2(1); v2 = q2(2:4);
crossProd = [ s1*s2 - dot(v1,v2), s1*v2 + s2*v1 + cross(v1,v2)];
end