function y = RK4(T,N,m0,q0,I)
        h=T/2^N;
        tend = length(0:h:T)-1;
         M(:,1)=m0;
         Q(:,1)=q0;
        y(:,1) = [M(:,1);Q(:,1)];               
    for t=1:tend  
         k_m(:,1)= h* getMdot(M(:,t),t,I);
         k_q(:,1)= h* getQdot(M(:,t),Q(:,t),I);

         k_m(:,2)= h* getMdot(M(:,t)   + .5*k_m(:,1), t + .5*h,I);
         k_q(:,2)= h* getQdot(M(:,t)   + .5*k_m(:,1), Q(:,t) + .5*k_q(:,1),I);

         k_m(:,3)= h* getMdot(M(:,t)  + .5*k_m(:,2), t + .5*h,I);
         k_q(:,3)= h* getQdot(M(:,t)  + .5*k_m(:,2), Q(:,t) + .5*k_q(:,2),I);

         k_m(:,4)= h* getMdot(M(:,t)  +  k_m(:,3), t + h,I);
         k_q(:,4)= h* getQdot(M(:,t)  +  k_m(:,3), Q(:,t) + k_q(:,3),I);

         M(:,t+1) = M(:,t) + (1/6)*(k_m * [1 ; 2 ; 2 ;1]);
         Q(:,t+1) = Q(:,t) + (1/6)*(k_q * [1 ; 2 ; 2 ;1]);
    % renormalize Q
%                 Q(:,t+1) = Q(:,t+1) ./ sqrt(dot(Q(:,t+1),Q(:,t+1))); 
            y(:,t+1) = [M(:,t+1);Q(:,t+1)];
    end

end
%% Euler Equation
function [Mdot] = getMdot(M,T,I)
Imat_inv = diag(diag(1./I));
Mdot = cross(M,Imat_inv*M);                                     
end
%% Arnold Equation
function [Qdot]=getQdot(M,Quat,I)
I = diag(I);
R =RotationMatrix(Quat);
invI = diag(1./I);
w = invI*M;
w_f = R*w;
Qdot = .5*quatMult(([0;w_f])',Quat');
Qdot = Qdot';
end
%% Rotation Matrix
function [R]=RotationMatrix(Quat)
R = [(1-2*(Quat(3)^2 + Quat(4)^2))         ,(-2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3))  , (2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4));
     (2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3)) , (1 - 2*(Quat(2)^2 + Quat(4)^2))        , (-2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4));
    (-2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4)) , (2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4))  , (1 - 2*(Quat(2)^2 + Quat(3)^2)) ];
end
%% Quaternion Multiplication
function [crossProd]=quatMult(q1,q2)
s1 = q1(1); v1 = q1(2:4);
s2 = q2(1); v2 = q2(2:4);
crossProd = [ s1*s2 - dot(v1,v2), s1*v2 + s2*v1 + cross(v1,v2)];
end