function y = SM(T,N,m0,q0,I,tol)
             h=T/2^N; 
            tend = length(0:h:T)-1; 
        for t=1:tend 
            e = 1.;
            M0(:,t+1) = zeros(3,1);
            Q0(:,t+1) = zeros(4,1);
            y(:,1) = [m0;q0];
            y0(:,t+1) = [M0(:,t+1);Q0(:,t+1)];
            while e>tol
                Am = (y0(1:3,t+1) + y(1:3,t))/norm(y0(1:3,t+1) + y(1:3,t));
                Aq = (y0(4:7,t+1) + y(4:7,t))/norm(y0(4:7,t+1) + y(4:7,t));
                y(:,t+1) = y(:,t) + h*[getMdot(Am,T,I);getQdot(Am,Aq,I)];
                y0(:,t+1) = y(:,t+1);
                Ae = (y0(1:3,t+1) + y(1:3,t))/norm(y0(1:3,t+1) + y(1:3,t));
                Be = (y0(4:7,t+1) + y(4:7,t))/norm(y0(4:7,t+1) + y(4:7,t));
                e = norm(y(:,t+1) - y(:,t) - h*[getMdot(Ae,T,I);getQdot(Ae,Be,I)]);
            end
        end 
end    
%% Euler Equation
function [Mdot] = getMdot(M,T,I)
Imat_inv = diag(diag(1./I));
Mdot = cross(M,Imat_inv*M);                                     
end
%% Arnold Equation
function [Qdot]=getQdot(M,Quat,I)
I = diag(I);
R =RotationMatrix(Quat);
invI = diag(1./I);
w = invI*M;
w_f = R*w;
Qdot = .5*quatMult(([0;w_f])',Quat');
Qdot = Qdot';
end
%% Rotation Matrix
function [R]=RotationMatrix(Quat)
R = [(1-2*(Quat(3)^2 + Quat(4)^2))         ,(-2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3))  , (2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4));
     (2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3)) , (1 - 2*(Quat(2)^2 + Quat(4)^2))        , (-2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4));
    (-2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4)) , (2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4))  , (1 - 2*(Quat(2)^2 + Quat(3)^2)) ];
end
%% Quaternion Multiplication
function [crossProd]=quatMult(q1,q2)
s1 = q1(1); v1 = q1(2:4);
s2 = q2(1); v2 = q2(2:4);
crossProd = [ s1*s2 - dot(v1,v2), s1*v2 + s2*v1 + cross(v1,v2)];
end