function [F]  = Error_shootEM(mp0)
global N phi epsilon L Cm Cp;

q0 = eye(3);
QL = [cos(phi), -sin(phi), 0;
      sin(phi), cos(phi), 0;
           0   ,   0     , 1];
q0 = rotMToEulerP(q0);
qL = rotMToEulerP(QL);      

invI = diag(diag(1./Cm));
invE = diag(diag(1./Cp));
h = L/(N);
v_i = 0:h:L;
n = length(v_i);

x = zeros(3,1);
xL = [0;0;(1-epsilon)*L];

% Initial values

pN = mp0(1:3);
mN = mp0(4:6);
qN = q0;
xN = x;
e3 = [0;0;1];
 y(:,1) =[pN;
          mN;
          qN;
          xN]; 
    for j=1:n-1
            % Predictor
           p_k = pN - (h/2)*hat(invI*mN)*pN;
           
           m_k = mN + (h/2)*(-hat(invI*mN)*mN - hat(invE*pN)*pN + hat(pN)*e3);

           AN = [0 ; invI*mN];
           
           q_k = qN + h/2*.5*quatMult(qN,AN);
           Q_N = QuatToMat(qN);
           x_k = xN + (h/2)*(Q_N*invE*pN + Q_N(:,3));
           
           % Corrector
           pN = pN - h*hat(invI*m_k)*p_k;
           
           mN = mN + h*(-hat(invI*m_k)*m_k - hat(invE*p_k)*p_k + hat(p_k)*e3);

           A_k = [0 ; invI*m_k];
           
           qN = qN + h*.5*quatMult(q_k,A_k);
           Q_k = QuatToMat(q_k);
           xN = xN + h*(Q_k*invE*p_k + Q_k(:,3));
           

          y(:,j+1) =[pN;
                     mN;
                      qN;
                     xN];  
    end
    
   F = [y(7:10,end);y(11:13,end)] - [qL;xL];
   nrm = norm(F);
       save('sol','y','v_i','nrm')

end

function vhat = hat(v);
vhat = [0, -v(3) , v(2);
        v(3) , 0 , -v(1);
        -v(2), v(1) , 0];
        
end
function exp_q = expQ(q)
        q0 = q(1);
        qv = q(2:end);
       exp_q = exp(q0).*[cos(norm(qv)) ;
                        qv./norm(qv)*sin(norm(qv))];
end
function [crossProd]=quatMult(q1,q2)
s1 = q1(1); v1 = q1(2:4);
s2 = q2(1); v2 = q2(2:4);
crossProd = [ s1*s2 - dot(v1,v2); s1*v2 + s2*v1 + cross(v1,v2)];
end
function [R]=QuatToMat(Quat)
R = [(1-2*(Quat(3)^2 + Quat(4)^2))         ,(-2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3))  , (2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4));
     (2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3)) , (1 - 2*(Quat(2)^2 + Quat(4)^2))        , (-2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4));
    (-2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4)) , (2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4))  , (1 - 2*(Quat(2)^2 + Quat(3)^2)) ];
end