function [F]  = Error_shootGL4(mp0)
global N phi epsilon L Cm Cp;

q0 = eye(3);
QL = [cos(phi), -sin(phi), 0;
      sin(phi), cos(phi), 0;
           0   ,   0     , 1];
q0 = rotMToEulerP(q0);
qL = rotMToEulerP(QL);      

h = L/(N);
v_i = 0:h:L;
n = length(v_i);
x = zeros(3,1);
xL = [0;0;(1-epsilon)*L];

% Initial values

pN = mp0(1:3);
mN = mp0(4:6);
qN = q0;
tol = 1e-10;
 y(:,1) =[pN;mN;qN;x];
 iter = 0;
for j=1:n-1
        e = 1.;
             k_p1_0 = zeros(3,1);
             k_m1_0 = zeros(3,1);
             k_q1_0 = zeros(4,1);
             k_p2_0 = zeros(3,1);
             k_m2_0 = zeros(3,1);
             k_q2_0 = zeros(4,1);
        while e>tol
         k_p1 =  getPdot(y(1:3,j)+ .25*h*k_p1_0 + (.25 - sqrt(3)/6)*h*k_p2_0,...
                           y(4:6,j)+ .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0,Cm);
         k_m1 =  getMdot(y(1:3,j)+ .25*h*k_p1_0 + (.25 - sqrt(3)/6)*h*k_p2_0,...
                           y(4:6,j)+ .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0,Cm,Cp);
         k_q1 =  getQdot(y(4:6,j)+ .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0,...
                           y(7:10,j)+ .25*h*k_q1_0 + (.25 - sqrt(3)/6)*h*k_q2_0,Cm);
         k_x1 =  getxdot(y(7:10,j)+ .25*h*k_q1_0 + (.25 - sqrt(3)/6)*h*k_q2_0,Cp,...
                         y(1:3,j)+ .25*h*k_p1_0 + (.25 - sqrt(3)/6)*h*k_p2_0);

         k_p2 =  getPdot(y(1:3,j) + (.25 + sqrt(3)/6)*h*k_p1_0 + .25*h*k_p2_0,...
                           y(4:6,j) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0,Cm);
         k_m2 =  getMdot(y(1:3,j) + (.25 + sqrt(3)/6)*h*k_p1_0 + .25*h*k_p2_0,...
                         y(4:6,j) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0,Cm,Cp);
         k_q2 =  getQdot(y(4:6,j) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0,...
                           y(7:10,j) + (.25 + sqrt(3)/6)*h*k_q1_0 + .25*h*k_q2_0,Cm);
         k_x2 =  getxdot(y(7:10,j) + (.25 + sqrt(3)/6)*h*k_q1_0 + .25*h*k_q2_0,Cp,...
                           y(1:3,j) + (.25 + sqrt(3)/6)*h*k_p1_0 + .25*h*k_p2_0);
                       
             k_p1_0 = k_p1;
             k_m1_0 = k_m1;
             k_q1_0 = k_q1;
             k_p2_0 = k_p2;
             k_m2_0 = k_m2;
             k_q2_0 = k_q2;

         Ekp1 = k_p1 -  getPdot(y(1:3,j)+ .25*h*k_p1_0 + (.25 - sqrt(3)/6)*h*k_p2_0,...
                           y(4:6,j)+ .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0,Cm);
         Ekm1 = k_m1 -  getMdot(y(1:3,j)+ .25*h*k_p1_0 + (.25 - sqrt(3)/6)*h*k_p2_0,...
                           y(4:6,j)+ .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0,Cm,Cp);
         Ekq1 = k_q1 -  getQdot(y(4:6,j)+ .25*h*k_m1_0 + (.25 - sqrt(3)/6)*h*k_m2_0,...
                           y(7:10,j)+ .25*h*k_q1_0 + (.25 - sqrt(3)/6)*h*k_q2_0,Cm);
         Ekx1 = k_x1 -  getxdot(y(7:10,j)+ .25*h*k_q1_0 + (.25 - sqrt(3)/6)*h*k_q2_0,Cp,...
                         y(1:3,j)+ .25*h*k_p1_0 + (.25 - sqrt(3)/6)*h*k_p2_0);

         Ekp2 = k_p2 -  getPdot(y(1:3,j) + (.25 + sqrt(3)/6)*h*k_p1_0 + .25*h*k_p2_0,...
                           y(4:6,j) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0,Cm);
         Ekm2 = k_m2 -  getMdot(y(1:3,j) + (.25 + sqrt(3)/6)*h*k_p1_0 + .25*h*k_p2_0,...
                         y(4:6,j) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0,Cm,Cp);
         Ekq2 = k_q2 - getQdot(y(4:6,j) + (.25 + sqrt(3)/6)*h*k_m1_0 + .25*h*k_m2_0,...
                           y(7:10,j) + (.25 + sqrt(3)/6)*h*k_q1_0 + .25*h*k_q2_0,Cm);
         Ekx2 = k_x2 - getxdot(y(7:10,j) + (.25 + sqrt(3)/6)*h*k_q1_0 + .25*h*k_q2_0,Cp,...
                           y(1:3,j) + (.25 + sqrt(3)/6)*h*k_p1_0 + .25*h*k_p2_0);
                       e = norm([Ekp1;Ekm1;Ekq1;Ekx1;Ekp2;Ekm2;Ekq2;Ekx2]);
               iter = iter + 1;
               if iter>100000
                    break
               end
        end
                k_p(:,1) = k_p1;
                k_m(:,1) = k_m1;
                k_q(:,1) = k_q1;
                k_x(:,1) = k_x1;
                k_p(:,2) = k_p2;
                k_m(:,2) = k_m2;
                k_q(:,2) = k_q2;
                k_x(:,2) = k_x2;
         y(1:3,j+1) = y(1:3,j) + (1/2)*h*(k_p * [1;1]);
         y(4:6,j+1) = y(4:6,j) + (1/2)*h*(k_m * [1;1]);
         y(7:10,j+1) = y(7:10,j) + (1/2)*h*(k_q * [1;1]);
          % renormalize Q
%              y(7:10,j+1) = y(7:10,j+1) ./ sqrt(dot(y(7:10,j+1),y(7:10,j+1)));   
         y(11:13,j+1) = y(11:13,j) + (1/2)*h*(k_x * [1;1]);
               
end

   F = [y(7:10,end);y(11:13,end)] - [qL;xL];
   v_is = v_i;
   nrm = norm(F);
        save('sol','y','v_is','nrm')

end

function qdot = getQdot(m,q,I)
    I = diag(I);
    invI = diag(1./I);
%Arnold Equation
qdot = .5*quatMult(q,([0;invI*m]));
% qdot=qdot';
end
function pdot = getPdot(P,M,I)
Imat_inv = diag(diag(1./I));
pdot = -hat(Imat_inv*M)*P;                                     
end
function mdot = getMdot(P,M,I,E)
Imat = diag(diag(I));
Imat_inv = diag(diag(1./I));
Emat = diag(diag(E));
Emat_inv = diag(diag(1./E));
e3 = [0;0;1];
mdot = -hat(Imat_inv*M)*M - hat(Emat_inv*P)*P + hat(P)*e3;                                     
end

function xdot=getxdot(q,E,P)
Q =  QuatToMat(q);
Emat = diag(diag(E));
Emat_inv = diag(diag(1./E));
xdot = Q * Emat_inv * P + Q(:,3);
end

function vhat = hat(v);
vhat = [0, -v(3) , v(2);
        v(3) , 0 , -v(1);
        -v(2), v(1) , 0];
        
end
function exp_q = expQ(q)
        q0 = q(1);
        qv = q(2:end);
       exp_q = exp(q0).*[cos(norm(qv)) ;
                        qv./norm(qv)*sin(norm(qv))];
end
function [crossProd]=quatMult(q1,q2)
s1 = q1(1); v1 = q1(2:4);
s2 = q2(1); v2 = q2(2:4);
crossProd = [ s1*s2 - dot(v1,v2); s1*v2 + s2*v1 + cross(v1,v2)];
end
function [R]=QuatToMat(Quat)
R = [(1-2*(Quat(3)^2 + Quat(4)^2))         ,(-2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3))  , (2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4));
     (2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3)) , (1 - 2*(Quat(2)^2 + Quat(4)^2))        , (-2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4));
    (-2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4)) , (2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4))  , (1 - 2*(Quat(2)^2 + Quat(3)^2)) ];
end