function [F]  = Error_shootIM(mp0)
global N phi epsilon L Cm Cp;

q0 = eye(3);
QL = [cos(phi), -sin(phi), 0;
      sin(phi), cos(phi), 0;
           0   ,   0     , 1];
q0 = rotMToEulerP(q0);
qL = rotMToEulerP(QL);      

invI = diag(diag(1./Cm));
invE = diag(diag(1./Cp));
h = L/(N);
v_i = 0:h:L;
n = length(v_i);
x = zeros(3,1);
xL = [0;0;(1-epsilon)*L];

% Initial values

pN = mp0(1:3);
mN = mp0(4:6);
qN = q0;
e3 = [0;0;1];
tol = 1e-10;
 y(:,1) =[pN;mN;qN;x]; 
    for j=1:n-1
        p_k0 = zeros(3,1);
        m_k0 = zeros(3,1);
        q_k0 = zeros(4,1);
        e = 1.;
        iter = 1;
       while e>tol
            % Finding midpoint
                midp = (y(1:3,j)   +  p_k0(:,1))*.5;
                midm = (y(4:6,j)   +  m_k0(:,1))*.5;
                midq = (y(7:10,j)   +  q_k0(:,1))*.5;
                    midq = midq/norm(midq);
            % Slope calculation using Implicit Midpoint
            p_k1 = y(1:3,j) - h*(hat(invI*midm)*midp);
            m_k1 = y(4:6,j) + h*(-hat(invI*midm)*midm - hat(invE*midp)*midp + hat(midp)*e3); 
                 A = [0 ; invI*midm];
            q_k1 = y(7:10,j) + h*.5*quatMult(midq,A); 
 
                        % Reassigning
                p_k0 = p_k1;
                m_k0 = m_k1;
                q_k0 = q_k1;
            % Checking Error  
                midp = (y(1:3,j)   +  p_k0(:,1))*.5;
                midm = (y(4:6,j)   +  m_k0(:,1))*.5;
                midq = (y(7:10,j)   +  q_k0(:,1))*.5;
                    midq = midq/norm(midq);
            Ep = p_k1 - y(1:3,j) + h*(hat(invI*midm)*midp);
            Em = m_k1 - y(4:6,j) - h*(-hat(invI*midm)*midm -hat(invE*midp)*midp + hat(midp)*e3);   
             A = [0 ; invI*midm];
            Eq = q_k1 - y(7:10,j) - h*.5*quatMult(midq,A);
            E_vec = [Ep;Em;Eq]; 
            e = norm(E_vec);  
            iter = iter + 1;
               if iter==100
                   break
               end
        end
            midp = (y(1:3,j)   +  p_k1(:,1))*.5;
            midq = (y(7:10,j)   + q_k1(:,1))*.5;
            Q_k1 = QuatToMat(midq);

            x_k1 = y(11:13,j) + h*(Q_k1*invE*midp + Q_k1(:,3));

          y(:,j+1) =[p_k1;
                     m_k1;
                     q_k1;
                     x_k1];  
    end   
   F = [y(7:10,end);y(11:13,end)] - [qL;xL];
   nrm = norm(F);
       save('sol','y','v_i','nrm')

end

function vhat = hat(v);
vhat = [0, -v(3) , v(2);
        v(3) , 0 , -v(1);
        -v(2), v(1) , 0];
        
end
function exp_q = expQ(q)
        q0 = q(1);
        qv = q(2:end);
       exp_q = exp(q0).*[cos(norm(qv)) ;
                        qv./norm(qv)*sin(norm(qv))];
end
function [crossProd]=quatMult(q1,q2)
s1 = q1(1); v1 = q1(2:4);
s2 = q2(1); v2 = q2(2:4);
crossProd = [ s1*s2 - dot(v1,v2); s1*v2 + s2*v1 + cross(v1,v2)];
end
function [R]=QuatToMat(Quat)
R = [(1-2*(Quat(3)^2 + Quat(4)^2))         ,(-2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3))  , (2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4));
     (2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3)) , (1 - 2*(Quat(2)^2 + Quat(4)^2))        , (-2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4));
    (-2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4)) , (2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4))  , (1 - 2*(Quat(2)^2 + Quat(3)^2)) ];
end