function [F]  = Error_shootKM(mp0)
global N phi epsilon L Cm Cp;

q0 = eye(3);
QL = [cos(phi), -sin(phi), 0;
      sin(phi), cos(phi), 0;
           0   ,   0     , 1];
q0 = rotMToEulerP(q0);
qL = rotMToEulerP(QL);      

h = L/(N);
v_i = 0:h:L;
n = length(v_i);

x = zeros(3,1);
xL = [0;0;(1-epsilon)*L];

% Initial values

pN = mp0(1:3);
mN = mp0(4:6);
qN = q0;
e3 = [0;0;1];
tol = 1e-10;
 y(:,1) =[pN;mN;qN;x]; 
    for j=1:n-1
        e=1.;
        y_k0=zeros(10,1);
        fn(:,j) = [getPdot(y(1:3,j),y(4:6,j),Cm);getMdot(y(1:3,j),y(4:6,j),Cm,Cp);getqdot(y(7:10,j),Cm,y(4:6,j))]; 
        iter = 0;
        while e>tol
            y_k1 = y(1:10,j) - h/2*fn(:,j) +...
                   2*h*[getPdot((y_k0(1:3,1)+y(1:3,j))/2,(y_k0(4:6,1)+y(4:6,j))/2,Cm);...
                         getMdot((y_k0(1:3,1)+y(1:3,j))/2,(y_k0(4:6,1)+y(4:6,j))/2,Cm,Cp);...
                         getqdot((y_k0(7:10,1)+y(7:10,j))/2,Cm,(y_k0(4:6,1)+y(4:6,j))/2)]-...
                   1/2*h*[getPdot(y_k0(1:3,1),y_k0(4:6,1),Cm);...
                            getMdot(y_k0(1:3,1),y_k0(4:6,1),Cm,Cp);...
                            getqdot(y_k0(7:10,1),Cm,y_k0(4:6,1))];
               y_k0 = y_k1;

               er =  y_k1 - y(1:10,j) + h/2*fn(:,j) -...
                   2*h*[getPdot((y_k0(1:3,1)+y(1:3,j))/2,(y_k0(4:6,1)+y(4:6,j))/2,Cm);...
                         getMdot((y_k0(1:3,1)+y(1:3,j))/2,(y_k0(4:6,1)+y(4:6,j))/2,Cm,Cp);...
                         getqdot((y_k0(7:10,1)+y(7:10,j))/2,Cm,(y_k0(4:6,1)+y(4:6,j))/2)] +...
                   1/2*h*[getPdot(y_k0(1:3,1),y_k0(4:6,1),Cm);getMdot(y_k0(1:3,1),y_k0(4:6,1),Cm,Cp);...
                           getqdot(y_k0(7:10,1),Cm,y_k0(4:6,1))];          
               e = norm(er);
               iter = iter + 1;
                   if iter==100
                       break
                   end
        end   
        y(1:10,j+1)=y_k1;  
                midp = (y(1:3,j)   +  y(1:3,j+1))*.5;
                midq = (y(7:10,j)   + y(7:10,j+1))*.5;
                    midq = midq/norm(midq);
            Qmid = QuatToMat(midq);
            Qk = QuatToMat(y(7:10,j));
            Qk1 = QuatToMat(y(7:10,j+1));

            x_k1 = y(11:13,j) - h*.5*getxdot(Qk,Cp,y(1:3,j)) + 2*h*getxdot(Qmid,Cp,midp) -...
                                    h*.5*getxdot(Qk1,Cp,y(1:3,j+1));

          y(11:13,j+1) =x_k1;
                        
    end    
   F = [y(7:10,end);y(11:13,end)] - [qL;xL];
   nrm = norm(F);
       save('sol','y','v_i','nrm')

end

function qdot = getqdot(q,I,m)
    Imat_inv = diag(diag(1./I));
    qdot = .5*quatMult(q,[0;Imat_inv*m]);
end
function pdot = getPdot(P,M,I)
Imat_inv = diag(diag(1./I));
pdot = -hat(Imat_inv*M)*P;                                     
end
function mdot = getMdot(P,M,I,E)
Imat_inv = diag(diag(1./I));
Emat_inv = diag(diag(1./E));
e3 = [0;0;1];
mdot = -hat(Imat_inv*M)*M - hat(Emat_inv*P)*P + hat(P)*e3;                                     
end

function xdot=getxdot(Q,E,P)
Emat_inv = diag(diag(1./E));
xdot = Q * Emat_inv * P + Q(:,3);
end

function vhat = hat(v);
vhat = [0, -v(3) , v(2);
        v(3) , 0 , -v(1);
        -v(2), v(1) , 0];
        
end
function exp_q = expQ(q)
        q0 = q(1);
        qv = q(2:end);
       exp_q = exp(q0).*[cos(norm(qv)) ;
                        qv./norm(qv)*sin(norm(qv))];
end
function [crossProd]=quatMult(q1,q2)
s1 = q1(1); v1 = q1(2:4);
s2 = q2(1); v2 = q2(2:4);
crossProd = [ s1*s2 - dot(v1,v2); s1*v2 + s2*v1 + cross(v1,v2)];
end
function [R]=QuatToMat(Quat)
R = [(1-2*(Quat(3)^2 + Quat(4)^2))         ,(-2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3))  , (2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4));
     (2*Quat(1)*Quat(4)+2*Quat(2)*Quat(3)) , (1 - 2*(Quat(2)^2 + Quat(4)^2))        , (-2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4));
    (-2*Quat(1)*Quat(3)+2*Quat(2)*Quat(4)) , (2*Quat(1)*Quat(2)+2*Quat(3)*Quat(4))  , (1 - 2*(Quat(2)^2 + Quat(3)^2)) ];
end